[Cherokee] [CHEROOKEE][CONTRIB] cherokee init script FEDORA COMPLIANT
Carlitux
carlotez at gmail.com
Sat Oct 7 00:13:59 CEST 2006
Of course... how could I forget SuSe init Scripts...but...
# Read http://www.tldp.org/HOWTO/HighQuality-Apps-HOWTO/ if you prefer not
# to use this template.
...the one you show me is for SUSE based systems, (althought) works fine for
Fedora, Red Hat, and SuSe based systems. My aproach is fresh and ligth as
the Web server, and I'm JUST asking to make a contrib/cherokee.fedora or
similar on the next release.
Kind Regards... :D
2006/10/6, Manuel Arostegui Ramirez <manuel at todo-linux.com>:
>
> El Viernes, 6 de Octubre de 2006 23:53, Carlitux escribió:
> > Hello Alvaro.
> >
> > Just my first time testing the cherokee web server, and I found a
> TRIVIAL
> > bug on the init script.I'm using Fedora Core 5 on a x86_64 based system
> and
> > wanted to start cherokee on startup, so I followed trying some steps:
> >
> > FC (and any RH-based distro) doesn't have the update-rc.d script;
> instead,
> > they have chkconfig. So, I created the link on /etc/rc.d and tried to
> > enable cherokee on chkconfig, but it failed,
> >
> > I build the last 0.5.5 tarball source, and all goes very good, so I went
> to
> > copy de contrib/cherokee init script to my /etc/init.d/ directory and
> for
> > make a link to the especial init scripts on /etc/rc[x].d, I use the
> redhat
> > chkconfig util,
> >
> > [root at localhost init.d]# chkconfig --add cherokee
> > service cherokee does not support chkconfig
> >
> > but I realize that the special line for chkconfig wasn't there, and all
> the
> > things I need for cherokee to start on my Fedora 5 x86_64 based system,
> > (ANGEL OF GOODNESS come to me and inspire me), so I made some
> investigation
> > of your DAEMON and the arguments, to finally wrote a contrib REDHAT
> FEDORA
> > compliant cherokee init script for all the folks who have problems with
> the
> > init so this is the new contrib/cherokee.server.fedora compliant:
> >
> > ******************************************************************
> > #!/bin/sh
> > #
> > # Contrib to RedHat Fedora Based Systems by: carlotez at gmail.com
> > # chkconfig: 2345 95 05
> > # description: Starts and stops the Cherokee ligth Web Server system
> > #
> >
> > # Source function library
> > . /etc/rc.d/init.d/functions
> >
> > NAME=cherokee
> > BASE=/usr/local/cherokee/sbin/$NAME
> > DAEMON="-b"
> > CONF="/etc/cherokee/cherokee.conf"
> > PIDFILE="/var/run/$NAME.pid"
> >
> > # Check that $BASE exists.
> > [ -f $BASE ] || exit 0
> >
> > # Source networking configuration.
> > . /etc/sysconfig/network
> >
> > # Check that networking is up.
> > [ ${NETWORKING} = "no" ] && exit 0
> >
> > RETVAL=0
> > # See how we were called.
> > case "$1" in
> > start)
> > if [ -n "`/sbin/pidof $NAME`" ]; then
> > echo -n $"$NAME: already running"
> > echo ""
> > exit $RETVAL
> > fi
> > echo -n "Starting Cherokee service: "
> > $BASE -C $CONF $DAEMON pidfile $PIDFILE
> > sleep 1
> > action "" /sbin/pidof $NAME
> > RETVAL=$?
> > [ $RETVAL -eq 0 ] && touch /var/lock/subsys/cherokee
> > ;;
> > stop)
> > echo -n "Shutting down Cherokee service: "
> > killproc $BASE
> > RETVAL=$?
> > echo
> > [ $RETVAL -eq 0 ] && rm -f /var/lock/subsys/cherokee
> > ;;
> > restart|reload)
> > $0 stop
> > $0 start
> > RETVAL=$?
> > ;;
> > status)
> > status $BASE
> > RETVAL=$?
> > ;;
> > *)
> > echo "Usage: $NAME {start|stop|restart|reload|status}"
> > exit 1
> > esac
> >
> > exit $RETVAL
> >
> > ******************************************************************
> >
> > Now everything is fine:
> >
> > [root at localhost init.d]# chkconfig --add cherokee
> >
> > [root at localhost init.d]# chkconfig cherokee on
> > [root at localhost init.d]# service cherokee start
> > Starting cherokee ...
> >
> > I could provide a patch, but I don't know how to send the initial script
> is
> > generated. So, long story short, this issue requires many changes
> >
> > Thats all Budy !!!
> > The Cherokee Server just fine on my Fedora 5 x86_64 based system
> > I hope you can made the changes to that script, or at least, made one
> > called contrib/cherokee.server.fedora with this contrib.
> >
> > I forgot to tell, I'm a former teacher of operating systems at my
> > university, and the shell programing is a base of that, so I came up
> with
> > this thing.
> >
> > Regards,
>
> Ummmmmmmm, that seems to work fine, of course.
> I'm afraid that there's already one start script for cherokee, which is
> skeleton-based, here it is:
>
> #!/bin/sh
> #
> # Fedora Linux init script for cherokee webserver, by Manuel Arostegui
> #Ramirez, original cherokee.init for Suse by:
>
> # Marcus Rueckert, SUSE / Novell Inc.
> # Copyright (C) 2006 Marcus Rueckert, SUSE / Novell Inc.
> #
> # This init script has the same license as the cherokee package
> itself.
> #
> # /etc/init.d/cherokee
> # and its symbolic link
> # /(usr/)sbin/rccherokee
> #
> # LSB compatible service control script; see
> http://www.linuxbase.org/spec/
> # Please send feedback to http://www.suse.de/feedback/
> #
> # Note: This template uses functions rc_XXX defined in /etc/rc.status on
> # UnitedLinux/SUSE/Novell based Linux distributions. However, it will work
> # on other distributions as well, by using the LSB (Linux Standard Base)
> # or RH functions or by open coding the needed functions.
> # Read http://www.tldp.org/HOWTO/HighQuality-Apps-HOWTO/ if you prefer not
> # to use this template.
> #
> # chkconfig: 345 99 00
> # description: FOO XYZ daemon providing ZYX
> #
> ### BEGIN INIT INFO
> # Provides: cherokee
> # Required-Start: $syslog $remote_fs
> # Should-Start: $time ypbind sendmail
> # Required-Stop: $syslog $remote_fs
> # Should-Stop: $time ypbind sendmail
> # Default-Start: 3 5
> # Default-Stop: 0 1 2 6
> # Short-Description: cherokee is a fast webserver
> # Description: cherokee is a fast webserver
> ### END INIT INFO
> #
> # Any extensions to the keywords given above should be preceeded by
> # X-VendorTag- (X-UnitedLinux- X-SuSE- for us) according to LSB.
> #
> # Notes on Required-Start/Should-Start:
> # * There are two different issues that are solved by Required-Start
> # and Should-Start
> # (a) Hard dependencies: This is used by the runlevel editor to determine
> # which services absolutely need to be started to make the start of
> # this service make sense. Example: nfsserver should have
> # Required-Start: $portmap
> # Also, required services are started before the dependent ones.
> # The runlevel editor will warn about such missing hard dependencies
> # and suggest enabling. During system startup, you may expect an
> error,
> # if the dependency is not fulfilled.
> # (b) Specifying the init script ordering, not real (hard) dependencies.
> # This is needed by insserv to determine which service should be
> # started first (and at a later stage what services can be started
> # in parallel). The tag Should-Start: is used for this.
> # It tells, that if a service is available, it should be started
> # before. If not, never mind.
> # * When specifying hard dependencies or ordering requirements, you can
> # use names of services (contents of their Provides: section)
> # or pseudo names starting with a $. The following ones are available
> # according to LSB (1.1):
> # $local_fs all local file systems are mounted
> # (most services should need this!)
> # $remote_fs all remote file systems are mounted
> # (note that /usr may be remote, so
> # many services should Require this!)
> # $syslog system logging facility up
> # $network low level networking (eth card, ...)
> # $named hostname resolution available
> # $netdaemons all network daemons are running
> # The $netdaemons pseudo service has been removed in LSB 1.2.
> # For now, we still offer it for backward compatibility.
> # These are new (LSB 1.2):
> # $time the system time has been set correctly
> # $portmap SunRPC portmapping service available
> # UnitedLinux/SUSE/Novell extensions:
> # $ALL indicates that a script should be inserted
> # at the end
> # * The services specified in the stop tags
> # (Required-Stop/Should-Stop)
> # specify which services need to be still running when this service
> # is shut down. Often the entries there are just copies or a subset
> # from the respective start tag.
> # * Should-Start/Stop are now part of LSB as of 2.0,
> # formerly SUSE/Unitedlinux used X-UnitedLinux-Should-Start/-Stop.
> # insserv does support both variants.
> # * X-UnitedLinux-Default-Enabled: yes/no is used at installation time
> # (%fillup_and_insserv macro in %post of many RPMs) to specify whether
> # a startup script should default to be enabled after installation.
> # It's not used by insserv.
> #
> # Note on runlevels:
> # 0 - halt/poweroff 6 - reboot
> # 1 - single user 2 - multiuser without network
> exported
> # 3 - multiuser w/ network (text mode) 5 - multiuser w/ network and X11
> (xdm)
> #
> # Note on script names:
> #
> http://www.linuxbase.org/spec/refspecs/LSB_1.3.0/gLSB/gLSB/scrptnames.html
> # A registry has been set up to manage the init script namespace.
> # http://www.lanana.org/
> # Please use the names already registered or register one or use a
> # vendor prefix.
>
>
> # Check for missing binaries (stale symlinks should not happen)
> # Note: Special treatment of stop for LSB conformance
> CHEROKEE_BIN=/usr/sbin/cherokee
> test -x $CHEROKEE_BIN || { echo "$CHEROKEE_BIN not installed";
> if [ "$1" = "stop" ]; then exit 0;
> else exit 5; fi; }
>
> # Check for existence of needed config file and read it
> # CHEROKEE_CONFIG=/etc/sysconfig/cherokee
> # test -r $CHEROKEE_CONFIG || { echo "$CHEROKEE_CONFIG not existing";
> # if [ "$1" = "stop" ]; then exit 0;
> # else exit 6; fi; }
>
> # Read config
> # . $CHEROKEE_CONFIG
>
> # Source LSB init functions
> # providing start_daemon, killproc, pidofproc,
> # log_success_msg, log_failure_msg and log_warning_msg.
> # This is currently not used by UnitedLinux based distributions and
> # not needed for init scripts for UnitedLinux only. If it is used,
> # the functions from rc.status should not be sourced or used.
> #. /lib/lsb/init-functions
>
> # Shell functions sourced from /etc/rc.status:
> # rc_check check and set local and overall rc status
> # rc_status check and set local and overall rc status
> # rc_status -v be verbose in local rc status and clear it
> afterwards
> # rc_status -v -r ditto and clear both the local and overall rc
> status
> # rc_status -s display "skipped" and exit with status 3
> # rc_status -u display "unused" and exit with status 3
> # rc_failed set local and overall rc status to failed
> # rc_failed <num> set local and overall rc status to <num>
> # rc_reset clear both the local and overall rc status
> # rc_exit exit appropriate to overall rc status
> # rc_active checks whether a service is activated by symlinks
>
> # Use the SUSE rc_ init script functions;
> # emulate them on LSB, RH and other systems
>
> # Default: Assume sysvinit binaries exist
> if test -e /etc/rc.status; then
> # SUSE rc script library
> . /etc/rc.status
> else
> export LC_ALL=POSIX
> start_daemon() { return /sbin/start_daemon ${1+"$@"}; }
> killproc() { return /sbin/killproc ${1+"$@"}; }
> pidofproc() { return /sbin/pidofproc ${1+"$@"}; }
> checkproc() { return /sbin/checkproc ${1+"$@"}; }
> _cmd=$1
> declare -a _SMSG
> if test "${_cmd}" = "status"; then
> _SMSG=(running dead dead unused unknown reserved)
> _RC_UNUSED=3
> else
> _SMSG=(done failed failed missed failed skipped unused failed
> failed
> reserved)
> _RC_UNUSED=6
> fi
> if test -e /lib/lsb/init-functions; then
> # LSB
> . /lib/lsb/init-functions
> echo_rc()
> {
> if test ${_RC_RV} = 0; then
> log_success_msg " [${_SMSG[${_RC_RV}]}] "
> else
> log_failure_msg " [${_SMSG[${_RC_RV}]}] "
> fi
> }
> # TODO: Add checking for lockfiles
> checkproc() { return pidofproc ${1+"$@"} >/dev/null 2>&1; }
> elif test -e /etc/init.d/functions; then
> # RHAT
> . /etc/init.d/functions
> echo_rc()
> {
> #echo -n " [${_SMSG[${_RC_RV}]}] "
> if test ${_RC_RV} = 0; then
> success " [${_SMSG[${_RC_RV}]}] "
> else
> failure " [${_SMSG[${_RC_RV}]}] "
> fi
> }
> checkproc() { return status ${1+"$@"}; }
> start_daemon() { return daemon ${1+"$@"}; }
> else
> # emulate it
> echo_rc() { echo " [${_SMSG[${_RC_RV}]}] "; }
> fi
> rc_reset() { _RC_RV=0; }
> rc_failed()
> {
> if test -z "$1"; then
> _RC_RV=1;
> elif test "$1" != "0"; then
> _RC_RV=$1;
> fi
> return ${_RC_RV}
> }
> rc_check()
> {
> return rc_failed $?
> }
> rc_status()
> {
> rc_failed $?
> if test "$1" = "-r"; then _RC_RV=0; shift; fi
> if test "$1" = "-s"; then rc_failed 5; echo_rc; rc_failed 3;
> shift; fi
> if test "$1" = "-u"; then rc_failed ${_RC_UNUSED}; echo_rc;
> rc_failed
> 3; shift; fi
> if test "$1" = "-v"; then echo_rc; shift; fi
> if test "$1" = "-r"; then _RC_RV=0; shift; fi
> return ${_RC_RV}
> }
> rc_exit() { exit ${_RC_RV}; }
> rc_active()
> {
> #if test -z "$RUNLEVEL"; then read RUNLEVEL REST <
> <(/sbin/runlevel);
> fi
> if test -e /etc/init.d/S[0-9][0-9]${1}; then return 0; fi
> return 1
> }
> fi
>
> # Reset status of this service
> rc_reset
>
> # Return values acc. to LSB for all commands but status:
> # 0 - success
> # 1 - generic or unspecified error
> # 2 - invalid or excess argument(s)
> # 3 - unimplemented feature (e.g. "reload")
> # 4 - user had insufficient privileges
> # 5 - program is not installed
> # 6 - program is not configured
> # 7 - program is not running
> # 8--199 - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
> #
> # Note that starting an already running service, stopping
> # or restarting a not-running service as well as the restart
> # with force-reload (in case signaling is not supported) are
> # considered a success.
>
> case "$1" in
> start)
> echo -n "Starting cherokee "
> ## Start daemon with startproc(8). If this fails
> ## the return value is set appropriately by startproc.
> start_daemon $CHEROKEE_BIN -b
>
> # Remember status and be verbose
> rc_status -v
> ;;
> stop)
> echo -n "Shutting down cherokee "
> ## Stop daemon with killproc(8) and if this fails
> ## killproc sets the return value according to LSB.
>
> killproc -TERM $CHEROKEE_BIN
>
> # Remember status and be verbose
> rc_status -v
> ;;
> try-restart|condrestart)
> ## Do a restart only if the service was active before.
> ## Note: try-restart is now part of LSB (as of 1.9).
> ## RH has a similar command named condrestart.
> if test "$1" = "condrestart"; then
> echo "${attn} Use try-restart ${done}(LSB)${attn} rather
> than
> condrestart ${warn}(RH)${norm}"
> fi
> $0 status
> if test $? = 0; then
> $0 restart
> else
> rc_reset # Not running is not a failure.
> fi
> # Remember status and be quiet
> rc_status
> ;;
> restart)
> ## Stop the service and regardless of whether it was
> ## running or not, start it again.
> $0 stop
> $0 start
>
> # Remember status and be quiet
> rc_status
> ;;
> force-reload)
> ## Signal the daemon to reload its config. Most daemons
> ## do this on signal 1 (SIGHUP).
> ## If it does not support it, restart the service if it
> ## is running.
>
> echo -n "Reload service cherokee "
> ## if it supports it:
> killproc -HUP $CHEROKEE_BIN
> #touch /var/run/cherokee.pid
> rc_status -v
>
> ## Otherwise:
> #$0 try-restart
> #rc_status
> ;;
> reload)
> ## Like force-reload, but if daemon does not support
> ## signaling, do nothing (!)
>
> # If it supports signaling:
> echo -n "Reload service cherokee "
> killproc -HUP $CHEROKEE_BIN
> #touch /var/run/cherokee.pid
> rc_status -v
>
> ## Otherwise if it does not support reload:
> #rc_failed 3
> #rc_status -v
> ;;
> status)
> echo -n "Checking for service cherokee "
> ## Check status with checkproc(8), if process is running
> ## checkproc will return with exit status 0.
>
> # Return value is slightly different for the status command:
> # 0 - service up and running
> # 1 - service dead, but /var/run/ pid file exists
> # 2 - service dead, but /var/lock/ lock file exists
> # 3 - service not running (unused)
> # 4 - service status unknown :-(
> # 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.)
>
> # NOTE: checkproc returns LSB compliant status values.
> checkproc $CHEROKEE_BIN
> # NOTE: rc_status knows that we called this init script with
> # "status" option and adapts its messages accordingly.
> rc_status -v
> ;;
> probe)
> ## Optional: Probe for the necessity of a reload, print out the
> ## argument to this init script which is required for a reload.
> ## Note: probe is not (yet) part of LSB (as of 1.9)
>
> test /etc/cherokee/cherokee.conf -nt /var/run/cherokee.pid && echo
> reload
> ;;
> *)
> echo "Usage: $0
> {start|stop|status|try-restart|restart|force-reload|
> reload|probe}"
> exit 1
> ;;
> esac
> rc_exit
>
>
>
> And here you are:
> [manu at Arbusto Desktop]$ sh cherokee.init start
> Starting cherokee
> [root at Arbusto ~]# sh /home/manu/cherokee/cherokee.init start
> Starting cherokee
> [root at Arbusto ~]#
> [root at Arbusto ~]# netstat -putan | grep -i cherokee
> tcp 0 0 0.0.0.0:80 0.0.0.0:*
> LISTEN 7530/cherokee
> [root at Arbusto ~]#
>
> Kind regards
> --
> Manuel Arostegui Ramirez.
>
> Electronic Mail is not secure, may not be read every day, and should not
> be used for urgent or sensitive issues.
> _______________________________________________
> Cherokee mailing list
> Cherokee at 0x50.org
> http://www.0x50.org/cgi-bin/mailman/listinfo/cherokee
>
--
---
Carlitux
Blog Personal: http://carlotez.blogspot.com/
"May the source be with you..."
"In a World without walls and fences who needs WINDOWS and GATES?"
http://counter.li.org/cgi-bin/certificate.cgi/409534
---
Ing. Carlos Alcalá Helguero
Administrador Encargado de Laboratorios de Computo
Universidad Catolica Boliviana "San Pablo"
Phone: (591)+4249234
Office: (591)+4293100 - Int. 247
Cel: 72735250
Cochabamba - Bolivia
GPG Key:
https://166.114.106.12/~carlotez/key.gpg.asc
pub 1024D/CD98DB19 2006-06-02 Ing. Carlos Javier Alcala Helguero
(Administrador de Laboratorios y Servidores) <carlotez at gmail.com>
GPG Fingerprint = BC12 864C 3A3E 9D09 8533 6B7A D3C2 EE1A CD98 DB19
-------------- next part --------------
An HTML attachment was scrubbed...
URL: http://lists.octality.com/pipermail/cherokee/attachments/20061006/f463fa99/attachment-0003.htm
More information about the Cherokee
mailing list